<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑送水订单' : '添加送水订单'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="用户水票ID" name="userTicketId">
        <a-input
          allow-clear
          placeholder="请输入用户水票ID"
          v-model:value="form.userTicketId"
        />
      </a-form-item>
      <a-form-item label="门店ID" name="storeId">
        <a-input
          allow-clear
          placeholder="请输入门店ID"
          v-model:value="form.storeId"
        />
      </a-form-item>
      <a-form-item label="配送员" name="riderId">
        <a-input
          allow-clear
          placeholder="请输入配送员"
          v-model:value="form.riderId"
        />
      </a-form-item>
      <a-form-item label="仓库ID" name="warehouseId">
        <a-input
          allow-clear
          placeholder="请输入仓库ID"
          v-model:value="form.warehouseId"
        />
      </a-form-item>
      <a-form-item label="关联收货地址" name="addressId">
        <a-input
          allow-clear
          placeholder="请输入关联收货地址"
          v-model:value="form.addressId"
        />
      </a-form-item>
      <a-form-item label="收货地址" name="address">
        <a-input
          allow-clear
          placeholder="请输入收货地址"
          v-model:value="form.address"
        />
      </a-form-item>
      <a-form-item label="买家留言" name="buyerRemarks">
        <a-input
          allow-clear
          placeholder="请输入买家留言"
          v-model:value="form.buyerRemarks"
        />
      </a-form-item>
      <a-form-item label="用于统计" name="price">
        <a-input
          allow-clear
          placeholder="请输入用于统计"
          v-model:value="form.price"
        />
      </a-form-item>
      <a-form-item label="购买数量" name="totalNum">
        <a-input
          allow-clear
          placeholder="请输入购买数量"
          v-model:value="form.totalNum"
        />
      </a-form-item>
      <a-form-item label="用户ID" name="userId">
        <a-input
          allow-clear
          placeholder="请输入用户ID"
          v-model:value="form.userId"
        />
      </a-form-item>
      <a-form-item label="备注" name="comments">
        <a-textarea
          :rows="4"
          :maxlength="200"
          placeholder="请输入描述"
          v-model:value="form.comments"
        />
      </a-form-item>
      <a-form-item label="状态" name="status">
        <a-radio-group v-model:value="form.status">
          <a-radio :value="0">显示</a-radio>
          <a-radio :value="1">隐藏</a-radio>
        </a-radio-group>
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addGltTicketOrder, updateGltTicketOrder } from '@/api/glt/gltTicketOrder';
  import { GltTicketOrder } from '@/api/glt/gltTicketOrder/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: GltTicketOrder | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<GltTicketOrder>({
    id: undefined,
    userTicketId: undefined,
    storeId: undefined,
    riderId: undefined,
    warehouseId: undefined,
    addressId: undefined,
    address: undefined,
    buyerRemarks: undefined,
    price: undefined,
    totalNum: undefined,
    userId: undefined,
    sortNumber: undefined,
    comments: undefined,
    status: undefined,
    deleted: undefined,
    tenantId: undefined,
    createTime: undefined,
    updateTime: undefined,
    gltTicketOrderId: undefined,
    gltTicketOrderName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    gltTicketOrderName: [
      {
        required: true,
        type: 'string',
        message: '请填写送水订单名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateGltTicketOrder : addGltTicketOrder;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
